Package com.google.protobuf

## Interface DescriptorProtos.FieldOptionsOrBuilder

All Superinterfaces:
  `GeneratedMessage.ExtendableMessageOrBuilder<DescriptorProtos.FieldOptions>`, `MessageLiteOrBuilder`, `MessageOrBuilder`

All Known Implementing Classes:
  `DescriptorProtos.FieldOptions`, `DescriptorProtos.FieldOptions.Builder`

Enclosing class:
  DescriptorProtos

    public static interface DescriptorProtos.FieldOptionsOrBuilder
    extends GeneratedMessage.ExtendableMessageOrBuilder<DescriptorProtos.FieldOptions>

### Method Summary

All Methods Instance Methods Abstract Methods
`DescriptorProtos.FieldOptions.CType` `getCtype()` `optional .google.protobuf.FieldOptions.CType ctype = 1 [default = STRING];`
`boolean` `getDeprecated()` `optional bool deprecated = 3 [default = false];`
`java.lang.String` `getExperimentalMapKey()` `optional string experimental_map_key = 9;`
`ByteString` `getExperimentalMapKeyBytes()` `optional string experimental_map_key = 9;`
`boolean` `getLazy()` `optional bool lazy = 5 [default = false];`
`boolean` `getPacked()` `optional bool packed = 2;`
`DescriptorProtos.UninterpretedOption` `getUninterpretedOption​(int index)` `repeated .google.protobuf.UninterpretedOption uninterpreted_option = 999;`
`int` `getUninterpretedOptionCount()` `repeated .google.protobuf.UninterpretedOption uninterpreted_option = 999;`
`java.util.List<DescriptorProtos.UninterpretedOption>` `getUninterpretedOptionList()` `repeated .google.protobuf.UninterpretedOption uninterpreted_option = 999;`
`DescriptorProtos.UninterpretedOptionOrBuilder` `getUninterpretedOptionOrBuilder​(int index)` `repeated .google.protobuf.UninterpretedOption uninterpreted_option = 999;`
`java.util.List<? extends DescriptorProtos.UninterpretedOptionOrBuilder>` `getUninterpretedOptionOrBuilderList()` `repeated .google.protobuf.UninterpretedOption uninterpreted_option = 999;`
`boolean` `getWeak()` `optional bool weak = 10 [default = false];`
`boolean` `hasCtype()` `optional .google.protobuf.FieldOptions.CType ctype = 1 [default = STRING];`
`boolean` `hasDeprecated()` `optional bool deprecated = 3 [default = false];`
`boolean` `hasExperimentalMapKey()` `optional string experimental_map_key = 9;`
`boolean` `hasLazy()` `optional bool lazy = 5 [default = false];`
`boolean` `hasPacked()` `optional bool packed = 2;`
`boolean` `hasWeak()` `optional bool weak = 10 [default = false];`

### Methods inherited from interface com.google.protobuf.GeneratedMessage.ExtendableMessageOrBuilder

`getDefaultInstanceForType, getExtension, getExtension, getExtensionCount, hasExtension`

### Methods inherited from interface com.google.protobuf.MessageLiteOrBuilder

`isInitialized`

### Methods inherited from interface com.google.protobuf.MessageOrBuilder

`findInitializationErrors, getAllFields, getDescriptorForType, getField, getInitializationErrorString, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, getUnknownFields, hasField, hasOneof`

### Method Detail

#### hasCtype

    boolean hasCtype()

`optional .google.protobuf.FieldOptions.CType ctype = 1 [default = STRING];`

     The ctype option instructs the C++ code generator to use a different
     representation of the field than it normally would.  See the specific
     options below.  This option is not yet implemented in the open source
     release -- sorry, we'll try to include it in a future version!

#### getCtype

    DescriptorProtos.FieldOptions.CType getCtype()

`optional .google.protobuf.FieldOptions.CType ctype = 1 [default = STRING];`

     The ctype option instructs the C++ code generator to use a different
     representation of the field than it normally would.  See the specific
     options below.  This option is not yet implemented in the open source
     release -- sorry, we'll try to include it in a future version!

#### hasPacked

    boolean hasPacked()

`optional bool packed = 2;`

     The packed option can be enabled for repeated primitive fields to enable
     a more efficient representation on the wire. Rather than repeatedly
     writing the tag and type for each element, the entire array is encoded as
     a single length-delimited blob.

#### getPacked

    boolean getPacked()

`optional bool packed = 2;`

     The packed option can be enabled for repeated primitive fields to enable
     a more efficient representation on the wire. Rather than repeatedly
     writing the tag and type for each element, the entire array is encoded as
     a single length-delimited blob.

#### hasLazy

    boolean hasLazy()

`optional bool lazy = 5 [default = false];`

     Should this field be parsed lazily?  Lazy applies only to message-type
     fields.  It means that when the outer message is initially parsed, the
     inner message's contents will not be parsed but instead stored in encoded
     form.  The inner message will actually be parsed when it is first accessed.
     This is only a hint.  Implementations are free to choose whether to use
     eager or lazy parsing regardless of the value of this option.  However,
     setting this option true suggests that the protocol author believes that
     using lazy parsing on this field is worth the additional bookkeeping
     overhead typically needed to implement it.
     This option does not affect the public interface of any generated code;
     all method signatures remain the same.  Furthermore, thread-safety of the
     interface is not affected by this option; const methods remain safe to
     call from multiple threads concurrently, while non-const methods continue
     to require exclusive access.
     Note that implementations may choose not to check required fields within
     a lazy sub-message.  That is, calling IsInitialized() on the outher message
     may return true even if the inner message has missing required fields.
     This is necessary because otherwise the inner message would have to be
     parsed in order to perform the check, defeating the purpose of lazy
     parsing.  An implementation which chooses not to check required fields
     must be consistent about it.  That is, for any particular sub-message, the
     implementation must either *always* check its required fields, or *never*
     check its required fields, regardless of whether or not the message has
     been parsed.

#### getLazy

    boolean getLazy()

`optional bool lazy = 5 [default = false];`

     Should this field be parsed lazily?  Lazy applies only to message-type
     fields.  It means that when the outer message is initially parsed, the
     inner message's contents will not be parsed but instead stored in encoded
     form.  The inner message will actually be parsed when it is first accessed.
     This is only a hint.  Implementations are free to choose whether to use
     eager or lazy parsing regardless of the value of this option.  However,
     setting this option true suggests that the protocol author believes that
     using lazy parsing on this field is worth the additional bookkeeping
     overhead typically needed to implement it.
     This option does not affect the public interface of any generated code;
     all method signatures remain the same.  Furthermore, thread-safety of the
     interface is not affected by this option; const methods remain safe to
     call from multiple threads concurrently, while non-const methods continue
     to require exclusive access.
     Note that implementations may choose not to check required fields within
     a lazy sub-message.  That is, calling IsInitialized() on the outher message
     may return true even if the inner message has missing required fields.
     This is necessary because otherwise the inner message would have to be
     parsed in order to perform the check, defeating the purpose of lazy
     parsing.  An implementation which chooses not to check required fields
     must be consistent about it.  That is, for any particular sub-message, the
     implementation must either *always* check its required fields, or *never*
     check its required fields, regardless of whether or not the message has
     been parsed.

#### hasDeprecated

    boolean hasDeprecated()

`optional bool deprecated = 3 [default = false];`

     Is this field deprecated?
     Depending on the target platform, this can emit Deprecated annotations
     for accessors, or it will be completely ignored; in the very least, this
     is a formalization for deprecating fields.

#### getDeprecated

    boolean getDeprecated()

`optional bool deprecated = 3 [default = false];`

     Is this field deprecated?
     Depending on the target platform, this can emit Deprecated annotations
     for accessors, or it will be completely ignored; in the very least, this
     is a formalization for deprecating fields.

#### hasExperimentalMapKey

    boolean hasExperimentalMapKey()

`optional string experimental_map_key = 9;`

     EXPERIMENTAL.  DO NOT USE.
     For "map" fields, the name of the field in the enclosed type that
     is the key for this map.  For example, suppose we have:
       message Item {
         required string name = 1;
         required string value = 2;
       }
       message Config {
         repeated Item items = 1 [experimental_map_key="name"];
       }
     In this situation, the map key for Item will be set to "name".
     TODO: Fully-implement this, then remove the "experimental_" prefix.

#### getExperimentalMapKey

    java.lang.String getExperimentalMapKey()

`optional string experimental_map_key = 9;`

     EXPERIMENTAL.  DO NOT USE.
     For "map" fields, the name of the field in the enclosed type that
     is the key for this map.  For example, suppose we have:
       message Item {
         required string name = 1;
         required string value = 2;
       }
       message Config {
         repeated Item items = 1 [experimental_map_key="name"];
       }
     In this situation, the map key for Item will be set to "name".
     TODO: Fully-implement this, then remove the "experimental_" prefix.

#### getExperimentalMapKeyBytes

    ByteString getExperimentalMapKeyBytes()

`optional string experimental_map_key = 9;`

     EXPERIMENTAL.  DO NOT USE.
     For "map" fields, the name of the field in the enclosed type that
     is the key for this map.  For example, suppose we have:
       message Item {
         required string name = 1;
         required string value = 2;
       }
       message Config {
         repeated Item items = 1 [experimental_map_key="name"];
       }
     In this situation, the map key for Item will be set to "name".
     TODO: Fully-implement this, then remove the "experimental_" prefix.

#### hasWeak

    boolean hasWeak()

`optional bool weak = 10 [default = false];`

     For Google-internal migration only. Do not use.

#### getWeak

    boolean getWeak()

`optional bool weak = 10 [default = false];`

     For Google-internal migration only. Do not use.

#### getUninterpretedOptionList

    java.util.List<DescriptorProtos.UninterpretedOption> getUninterpretedOptionList()

`repeated .google.protobuf.UninterpretedOption uninterpreted_option = 999;`

     The parser stores options it doesn't recognize here. See above.

#### getUninterpretedOption

    DescriptorProtos.UninterpretedOption getUninterpretedOption​(int index)

`repeated .google.protobuf.UninterpretedOption uninterpreted_option = 999;`

     The parser stores options it doesn't recognize here. See above.

#### getUninterpretedOptionCount

    int getUninterpretedOptionCount()

`repeated .google.protobuf.UninterpretedOption uninterpreted_option = 999;`

     The parser stores options it doesn't recognize here. See above.

#### getUninterpretedOptionOrBuilderList

    java.util.List<? extends DescriptorProtos.UninterpretedOptionOrBuilder> getUninterpretedOptionOrBuilderList()

`repeated .google.protobuf.UninterpretedOption uninterpreted_option = 999;`

     The parser stores options it doesn't recognize here. See above.

#### getUninterpretedOptionOrBuilder

    DescriptorProtos.UninterpretedOptionOrBuilder getUninterpretedOptionOrBuilder​(int index)

`repeated .google.protobuf.UninterpretedOption uninterpreted_option = 999;`

     The parser stores options it doesn't recognize here. See above.